require 'http'
require 'emt_api/response'

module EmtApi
  class Api
    GET_LIST_LINES_URL = 'https://openbus.emtmadrid.es:9443/emt-proxy-server/last/bus/GetListLines.php'
    GET_NODE_LINES_URL = 'https://openbus.emtmadrid.es:9443/emt-proxy-server/last/bus/GetNodesLines.php'
    EMT_CLIENT = ENV['EMT_CLIENT']
    EMT_SECRET = ENV['EMT_SECRET']

    def self.get_list_lines(line_ids = nil, date = Time.now)

      http_response = HTTP.post(GET_LIST_LINES_URL, form: {
        idClient: EMT_CLIENT,
        passKey: EMT_SECRET,
        SelectDate: date.strftime("%d/%m/%Y"),
        Lines: line_ids
      })

      emt_response = EmtApi::Response.new(http_response)

      emt_response.valid_data? ? emt_response.data : nil
    end

    # Recupera todos los identificadores de parada, junto con su coordenada UTM,
    # nombre y la relación de líneas/sentido que pasan por cada uno de ellos.
    def self.get_nodes_lines(stop_id = nil)

      http_response = HTTP.post(GET_NODE_LINES_URL, form: {
          idClient: EMT_CLIENT,
          passKey: EMT_SECRET,
          Nodes: stop_id
      })

      emt_response = EmtApi::Response.new(http_response)

      emt_response.valid_data? ? emt_response.data : nil
    end

  end
end
