require 'emt_api/parser'
require 'emt_api/api'

module EmtApi
  class Line
    attr_accessor :id, :label, :group_number, :date_first, :date_end, :origin, :destination

    def initialize(line_data = {})
      @id           = line_data['line']
      @label        = line_data['label']
      @group_number = line_data['groupNumber'].to_i
      @date_first   = EmtApi::Parser.parse_date line_data['dateFirst']
      @date_end     = EmtApi::Parser.parse_date line_data['dateEnd']
      @origin       = EmtApi::Parser.parse_sentence line_data['nameA']
      @destination  = EmtApi::Parser.parse_sentence line_data['nameB']
    end

    def self.all
      response_data = EmtApi::Api.get_list_lines
      lines = []

      unless response_data.nil?
        response_data.each { |line| lines << EmtApi::Line.new(line) }
      end

      lines
    end

    def self.find(id)
      response_data = EmtApi::Api.get_list_lines(id)
      response_data.nil? ? nil : EmtApi::Line.new(response_data)
    end

  end
end
