module EmtApi
  class Parser

    def self.parse_date(date_string)
      date_string = remove_trailing_whitespaces(date_string)
      Date.parse(date_string)
    end

    def self.parse_sentence(sentence)
      sentence = remove_trailing_whitespaces(sentence)
      sentence = add_spaces_between_separators(sentence)
      capitalize_sentence(sentence)
    end

    def self.remove_trailing_whitespaces(sentence)
      sentence.rstrip
    end

    def self.add_spaces_between_separators(sentence)
      spaced_sentence = sentence

      # Add space before the '-' character
      spaced_sentence.gsub!(/(?!\s)\-/, ' -')

      # Add space after the '-' character
      spaced_sentence.gsub!(/\-(?!\s)/, '- ')

      # Add space after the '.' used for abbreviations
      spaced_sentence.gsub!(/\.(?!\s)/, '. ')

      spaced_sentence
    end

    def self.capitalize_sentence(sentence)
      sentence.split.map { |word| word.capitalize }.join(' ')
    end

  end
end
