module EmtApi
  class Response
    attr_accessor :code, :result_code, :result_description, :data

    def initialize(response)
      @code = response.code
      if successful?
        json_response = JSON.parse(response.body)
        @result_code = json_response['resultCode']
        @result_description = json_response['resultDescription']
        if valid_result?
          @data = json_response['resultValues']
        end
      end
    end

    def successful?
      code == 200
    end

    def valid_result?
      result_code == 0
    end

    def valid_data?
      successful? && valid_result?
    end

  end
end
