require 'byebug'

module EmtApi
  class Stop
    attr_accessor :id, :name, :lines, :latitude, :longitude

    def initialize(stop_data = {})
      @id         = stop_data['node']
      @name       = EmtApi::Parser.parse_sentence stop_data['name']
      @lines      = stop_data['lines']
      @wifi       = (stop_data['Wifi'].to_i == 1)
      @latitude   = stop_data['latitude']
      @longitude  = stop_data['longitude']
    end

    def self.all
      response_data = EmtApi::Api.get_nodes_lines
      stops = []

      unless response_data.nil?
        response_data.each { |stop| stops << EmtApi::Stop.new(stop) }
      end

      stops
    end

    def self.find(id)
      response_data = EmtApi::Api.get_nodes_lines(id)
      response_data.nil? ? nil : EmtApi::Stop.new(response_data)
    end

    def wifi?
      @wifi
    end

  end
end
